/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-07 17:46
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============

// T, NEUTRAL and m() depend on f
typedef int T;
const T NEUTRAL = 0;
T m(T l, T r){ return l ^ r; }
struct interval_tree {
  int N;
  vector<T> t;
  interval_tree(vector<int> &a){
    N = bit_ceil(size(a) + 1);
    t.assign(2 * N, NEUTRAL);
    for(int i = 0; i < ssize(a); i++)
      t[N - 1 + i] = a[i]; // <- adjust as needed
    for(int i = N - 2; i >= 0; i--)
      t[i] = m(t[lc(i)], t[rc(i)]);
  }
  T get(int l, int r){
    l += N - 1, r += N - 1;
    T res = NEUTRAL;
    while(l <= r && (l != 0 || r != 0)){
      if(l % 2 == 0) res = m(res, t[l++]);
      if(r % 2 == 1) res = m(res, t[r--]);
      l = pa(l), r = pa(r);
    }
    return res;
  }
  void set(int p, T val){
    p += N - 1, t[p] = val;
    while(p > 0) // <=> while p != pa(p)
      p = pa(p), t[p] = m(t[lc(p)], t[rc(p)]);
  }
  int pa(int x){ return (x - 1) / 2; }
  int lc(int x){ return 2 * x + 1; }
  int rc(int x){ return 2 * x + 2; }
};


ll N;

void solve_interval_tree(){
    // Code goes here ...
    cin >> N;

    vector<int> nums(N);
    R(i, N) cin >> nums[i];

    string s;
    cin >> s;

    int sum = 0, onsum = 0;
    R(i, N){
        sum ^= nums[i];
        if(s[i] == '1')
            onsum ^= nums[i];
    }

    interval_tree tree(nums);

    int Q;
    cin >> Q;

    int mode;
    int l, r;
    int x;
    R(i, Q){
        cin >> mode;
        if(mode == 1){
            cin >> l >> r;
            onsum ^= tree.get(l - 1, r - 1);
        }
        else{
            cin >> x;
            cout << (x ? onsum : (sum ^ onsum)) << " ";
        }
    }
    cout << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve_interval_tree();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
